<template>
  <div>
    <div v-if="isAuthenticated" class="flex flex-col gap-3">
      <Listbox v-if="projects" as="div" v-model="selectedProject">
        <ListboxLabel class="form-label inline-block text-gray-700">Select a project</ListboxLabel>
        <div class="mt-1 relative">
          <ListboxButton
              class="relative w-full bg-white border border-gray-300 rounded-md shadow-sm pl-3 pr-10 py-2 text-left cursor-default focus:outline-none focus:ring-1 focus:ring-indigo-500 focus:border-indigo-500 sm:text-sm">
            <span class="ml-3 block truncate">{{ selectedProject.name }}</span>
            <span class="ml-3 absolute inset-y-0 right-0 flex items-center pr-2 pointer-events-none">
          <SelectorIcon class="h-5 w-5 text-gray-400" aria-hidden="true"/>
        </span>
          </ListboxButton>
          <transition leave-active-class="transition ease-in duration-100" leave-from-class="opacity-100"
                      leave-to-class="opacity-0">
            <ListboxOptions
                class="absolute z-10 mt-1 w-full bg-white shadow-lg max-h-56 rounded-md py-1 text-base ring-1 ring-black ring-opacity-5 overflow-auto focus:outline-none sm:text-sm">
              <ListboxOption as="template" v-for="p in projects" :key="p.id" :value="p"
                             v-slot="{ active, selectedProject }">
                <li :class="[active ? 'text-white bg-indigo-600' : 'text-gray-900', 'cursor-default select-none relative py-2 pl-3 pr-9']">
                  <div class="flex items-center">
                    <span :class="[selectedProject ? 'font-semibold' : 'font-normal', 'ml-3 block truncate']">{{
                        p.name
                      }}</span>
                  </div>
                  <span v-if="selectedProject"
                        :class="[active ? 'text-white' : 'text-indigo-600', 'absolute inset-y-0 right-0 flex items-center pr-4']">
                    <CheckIcon class="h-5 w-5" aria-hidden="true"/>
                  </span>
                </li>
              </ListboxOption>
            </ListboxOptions>
          </transition>
        </div>
      </Listbox>
      <div class="flex flex-col">
        <label for="fileUpload" class="form-label text-gray-700">Upload a file</label>
        <label
            id="fileUpload"
            class="mt-1 inline-flex justify-center py-6 px-4 border-2 border-dashed border-gray-200 rounded-lg text-sm font-medium rounded-md text-gray-700 bg-white hover:border-gray-300 hover:text-gray-900 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500">
          "Scan" by drag 'n' dropping a file here, or clicking to select a file
          <input @change="onFileSelected" type="file" class="hidden"/>
        </label>
        <PulseLoader v-if="isProcessing" class="my-4 self-center" />
      </div>
    </div>
    <div v-else class="flex flex-col gap-3">
      <label for="clientCredentials">API credentials</label>
      <input type="text"
             id="clientCredentials"
             class="focus:ring-indigo-500 focus:border-indigo-500 block w-full shadow-sm sm:text-sm border-gray-300 rounded-md"
             v-model="clientId" placeholder="Enter client ID">
      <input type="password"
             class="focus:ring-indigo-500 focus:border-indigo-500 block w-full shadow-sm sm:text-sm border-gray-300 rounded-md"
             v-model="clientSecret" placeholder="Enter client secret">
      <div class="py-3">
        <button type="submit"
                @click="onSaveCredentials"
                class="inline-flex justify-center py-2 px-4 border border-transparent shadow-sm text-sm font-medium
          rounded-md text-white bg-indigo-600 hover:bg-indigo-700 focus:outline-none focus:ring-2
          focus:ring-offset-2 focus:ring-indigo-500">
          Save
        </button>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import {useRouter} from "vue-router";
import {useCookies} from "vue3-cookies";
import {defineComponent} from "vue";
import {doTokenValidation, fileCollectionService, projectService, streamService} from "@/services/services";
import {Listbox, ListboxButton, ListboxLabel, ListboxOption, ListboxOptions} from '@headlessui/vue'
import {CheckIcon, SelectorIcon} from '@heroicons/vue/solid'
import {Project} from "@/services/projectResponse";
import {RouteNames} from "@/router";
import PulseLoader from 'vue-spinner/src/PulseLoader.vue'

enum ClientAction {
  Validation,
  Export
}

export default defineComponent({
  name: 'Scan',
  components: {
    Listbox,
    ListboxButton,
    ListboxLabel,
    ListboxOption,
    ListboxOptions,
    CheckIcon,
    SelectorIcon,
    PulseLoader,
  },
  data() {
    const router = useRouter()
    const {cookies} = useCookies()

    return {
      router,
      cookies,
      isAuthenticated: false,
      isProcessing: false,
      selectedProject: {} as Project,
      projects: [] as Project[],
      clientId: "",
      clientSecret: "",
      apiUrl: cookies.get("apiUrl"),
    }
  },
  async mounted() {
    const getAllResponse = await projectService.getAll()
    this.projects = getAllResponse.projects
    this.selectedProject = getAllResponse.projects[0]
    this.isAuthenticated = await doTokenValidation()
  },
  methods: {
    async onSaveCredentials() {
      this.cookies.set("clientId", this.clientId)
      this.cookies.set("clientSecret", this.clientSecret)
      this.isAuthenticated = await doTokenValidation()
    },
    async onFileSelected(e: any) {
      const file = e.target.files[0] as File
      const fileCollectionResponse = await fileCollectionService.create(file)
      const fileCollectionId = fileCollectionResponse.id
      console.log("created file collection", fileCollectionId)

      try {
        this.isProcessing = true;
        const streamResponse = await streamService.create(fileCollectionId, this.selectedProject.id)
        console.log("created stream", streamResponse.id)

        // Wait for the stream to be ready for either validation or export
        // This method throws an error if the stream goes into an unexpected state
        // For simplicity it does not time out. A real application should not wait forever.
        const nextAction = await streamService.waitForStartClientActionState(streamResponse.id)

        if (nextAction == "validation") {
          await this.router.push({name: RouteNames.Validate, params: {streamId: streamResponse.id}})
        } else {
          // stream is ready for export
          await this.router.push({name: RouteNames.Export, params: {streamId: streamResponse.id}})
        }

      } catch (e) {
        console.error(e);
        alert(e);
      } finally {
        this.isProcessing = false;
      }
    }
  },
});
</script>
